"use strict";
/*!
 *
 * Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 */
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
const Span_1 = tslib_1.__importDefault(require("../../trace/span/Span"));
const AgentConfig_1 = tslib_1.__importDefault(require("../../config/AgentConfig"));
const Tracing_pb_1 = require("../../proto/language-agent/Tracing_pb");
const ContextCarrier_1 = require("../context/ContextCarrier");
class ExitSpan extends Span_1.default {
    constructor(options) {
        super(Object.assign(options, {
            type: Tracing_pb_1.SpanType.EXIT,
        }));
    }
    inject() {
        return new ContextCarrier_1.ContextCarrier(this.context.segment.relatedTraces[0], this.context.segment.segmentId, this.id, AgentConfig_1.default.serviceName, AgentConfig_1.default.serviceInstance, this.operation, this.peer, []);
    }
}
exports.default = ExitSpan;
//# sourceMappingURL=ExitSpan.js.map